﻿FuBar = {}
FuBar.version = "2.0"
FuBar.db = {}
FuBar.db.profile = {}

local broker = LibStub("LibDataBroker-1.1")
local brokerPlugins = {}

local hooked, origSetIcon, origSetText

function FuBar:ShowPlugin(plugin)
	local name = plugin:ToString()
	local brokerPlugin = broker:NewDataObject(name)
	brokerPlugin.text = name
	brokerPlugin.icon = plugin.icon or plugin.hasIcon
	
	plugin.brokerPlugin = brokerPlugin
	
	-- dirty hack, we only need to hook FuBarPlugin once, hopefully this won't cause problems
	if not hooked then
		origSetIcon = plugin.SetIcon
		origSetText = plugin.SetText
		plugin.SetIcon = function(self, path) origSetIcon(self, path) self.brokerPlugin.icon = path end
		plugin.SetText = function(self, text) origSetText(self, text) self.brokerPlugin.text = text end
		hooked = true
	end
	
	brokerPlugins[name] = brokerPlugin
end

function FuBar:RegisterPlugin(plugin)
end